from enigma import *
from Screens.Screen import Screen
from Plugins.Plugin import PluginDescriptor

class ShellStarter(Screen):
	skin = """
		<screen position="1,1" size="1,1" title="TuxTXT" >
                </screen>"""

        def __init__(self, session, args = None):
        	self.skin = ShellStarter.skin
		Screen.__init__(self, session)
		self.container=eConsoleAppContainer()
		self.container.appClosed.append(self.finished)
		self.runapp()
		
	def runapp(self):
		service = self.session.nav.getCurrentService()
		if service is not None:
			self.info = service.info()
		else:
			self.info = None

		eRCInput.getInstance().lock()
		self.container.execute("/usr/bin/tuxtxt "+self.getValue(iServiceInformation.sTXTPID))

	def finished(self,retval):
		eRCInput.getInstance().unlock()
		self.close()

	def getValue(self, what):
		if self.info is None:
			return ""
		
		v = "%d" % (self.info.getInfo(what))

		return v


def main(session, **kwargs):
	session.open(ShellStarter)

def Plugins(**kwargs):
	return PluginDescriptor(name="TuxTXT", description="Videotext", where = PluginDescriptor.WHERE_TELETEXT, fnc=main)
