# PKTeam.pl by Father Pio

from Screens.Screen import Screen
from Screens.MessageBox import MessageBox
from Plugins.Plugin import PluginDescriptor
from Tools import Notifications
from Components.Pixmap import Pixmap, MovingPixmap
from Components.ActionMap import ActionMap, NumberActionMap
from Components.Button import Button
from Components.Label import Label
from Components.Console import Console
from Components.ConfigList import ConfigList
from Components.config import config
from Components.ConfigList import ConfigListScreen

import os
import time
from Screens.MessageBox import MessageBox
	
import gettext

try:
	cat = gettext.translation('lang', '/usr/lib/enigma2/python/Plugins/Extensions/PKT_SkinSetup/po', [config.osd.language.getText()])
	_ = cat.gettext
except IOError:
	pass

my_global_session = None
		
class ReplaceFont(ConfigListScreen, Screen):	
		
	skin = """
		<screen position="center,center" size="650,170" title="EPG Font Setup" >
		<widget name="opis1" position="10,10" size="620,30" font="Regular;22" halign="center" valign="top" foregroundColor="#ffffff"  />
		<widget name="opis2" position="10,50" size="620,30" font="Regular;22" halign="center" valign="top" foregroundColor="#ffffff"  />
		
		<ePixmap pixmap="skin_default/buttons/key_red.png"    zPosition="1" position="50,140" size="36,36" alphatest="on" />
		<ePixmap pixmap="skin_default/buttons/key_green.png"  zPosition="1" position="250,140" size="36,36" alphatest="on" />
		<ePixmap pixmap="skin_default/buttons/key_blue.png"  zPosition="1" position="450,140" size="36,36" alphatest="on" />
		
		<widget name="key_red" 		position="80,142"	size="190,28"  font="Regular;18" halign="left" valign="top" foregroundColor="#ffffff"  />
		<widget name="key_green" 	position="280,142" 	size="190,28"  font="Regular;18" halign="left" valign="top" foregroundColor="#ffffff" />	
		<widget name="key_blue" 	position="480,142" 	size="190,28"  font="Regular;18" halign="left" valign="top" foregroundColor="#ffffff" />	
		
	</screen>"""

	def __init__(self, session, args = None):
		Screen.__init__(self, session)
		
		self["opis1"] = Label(_("This is solution on problem with EPG fonts."))
		self["opis2"] = Label(_("If you want to do changes then choose selection."))
		self.Console = Console()
                self["key_red"] = Button(_("Cancel"))
                self["key_green"] = Button(_("Change"))
                self["key_blue"] = Button(_("Undo"))
				
		self["PKTinforBarSetup"] = ActionMap(["PKTinforBarSetup"],
		{
			"save": self.change,
			"cancel": self.cancel,
			"undoEPG": self.undo,
		}, -2)
	
	def change(self):
		if (os.path.isfile("/usr/share/fonts/cool.old") == False):
			os.system('cp -f /usr/share/fonts/cool.ttf /usr/share/fonts/cool.old')
			os.system('cp -f /usr/share/fonts/nmsbd.ttf /usr/share/fonts/cool.ttf')
			
			os.system('cp -f /usr/share/fonts/bahamas.ttf /usr/share/fonts/bahamas.old')
			os.system('cp -f /usr/share/fonts/nmsbd.ttf /usr/share/fonts/bahamas.ttf')
			
			os.system("sync")
			time.sleep (1)
			self.session.openWithCallback(self.restart,MessageBox,_("GUI needs a restart to apply a font changes.\nDo you want to restart the GUI now ?"), MessageBox.TYPE_YESNO)		
		self.close()
	
	def undo(self):	
		if (os.path.isfile("/usr/share/fonts/cool.old") == True):
			os.system('cp -f /usr/share/fonts/cool.old /usr/share/fonts/cool.ttf')
			os.system('rm -f /usr/share/fonts/cool.old')
			os.system('cp -f /usr/share/fonts/bahamas.old /usr/share/fonts/bahamas.ttf')
			os.system('rm -f /usr/share/fonts/bahamas.old')
			os.system("sync")
			time.sleep (1)
			self.session.openWithCallback(self.restart,MessageBox,_("GUI needs a restart to undo changes.\nDo you want to restart the GUI now ?"), MessageBox.TYPE_YESNO)
		self.close()
			
	def cancel(self):
		self.close()
			
	def restart(self, answer):
		if answer is True:
			os.system('killall enigma2')
			
